#include <stdio.h>              /* for printf */
#include <stdlib.h>             /* for malloc, if used */
#include <stddef.h>             /* for luck */
/*  These first three lines should be a standard part of all programs for
    general use.
*/

#include <dos.h>                /* needed  for Far Pointer Definition */
#include "fdc_bs.h"             /* header for this program */


main(int argc, char **argv)
  {int      i, porta, bytea;

   int      num_of_diskettes,color_vid,error_status;
   auto     unsigned int  far *wordpntr;    /* Auto is the default, but added
                                               here for completeness */
   auto     unsigned char far *bytepntr;
     /* A Flag bit in this byte is controlled by an interrupt in made it
        volatile in case I changes while I am not looking. */
   volatile unsigned char far *vobytepntr;  

   printf(" Floppy Disk Controller Bios Status v1.0\n");
   printf("============================================\n");

    /* Get Installed Hardware list form the BIOS data Segment */
   wordpntr = MK_FP(BiosDataSeg, InHardware);
   color_vid = *wordpntr & 0x30;              /* get current video mode
                                                 for use with later versions */
   if (((*wordpntr) & 0x01) == 0x01) printf("Bootable disk Available!");
     else printf("Bootable disk not found!");
   num_of_diskettes = (((*wordpntr) & 0xc0) >> 5) - 1;  /* get number of
                                                           diskettes avail. */
   printf("\t\tNumber of diskette(s) available %d \n",num_of_diskettes);

   /* Diskette Recalibration Status Byte */
   vobytepntr = MK_FP(BiosDataSeg, DsktRecalStatus);
   printf("\nDiskette ReCalibration Status Byte : %x \n",*vobytepntr);
   printf("============================================\n");
   if (((*vobytepntr) & 0x80) == 0x80) printf("Interrupt service pending!\n");
   switch (num_of_diskettes)
   {case 4 :
     if (((*vobytepntr) & 0x08) != 0x08) printf("Drive 3 needs to be reset.\n");
    case 3 :
     if (((*vobytepntr) & 0x04) != 0x04) printf("Drive 2 needs to be reset.\n");
    case 2 :
     if (((*vobytepntr) & 0x02) != 0x02) printf("Drive 1 needs to be reset.\n");
      else printf("Drive 1 OK \t");
    case 1 :
     if (((*vobytepntr) & 0x01) != 0x01) printf("Drive 0 needs to be reset.\n");
      else printf("Drive 0 OK \n");
    break;
    default : printf("Error in readin Diskette Recalibration Byte!!!\n");
   }

   /* Diskette Motor Status Byte */
   bytepntr = MK_FP(BiosDataSeg, DsktMotorStatus);
   printf("\nDiskette Motor Status Byte : %x \n",*bytepntr);
   printf("============================================\n");
   if (((*bytepntr) & 0x0f) == 0x00) printf("All Motors OFF.\n");
   switch (num_of_diskettes)
   {case 4 :
     if (((*bytepntr) & 0x08) == 0x08) printf("Drive 3 motor on.\n");
    case 3 :
     if (((*bytepntr) & 0x04) == 0x04) printf("Drive 2 motor on.\n");
    case 2 :
     if (((*bytepntr) & 0x02) == 0x02)
      {printf("Drive 1 motor on.\n");
       if (((*bytepntr) & 0x80) == 0x80) printf("Diskette write or format in progress.\n");
         else printf("Diskette read or seek in progress.\n");
      }
    case 1 :
     if (((*bytepntr) & 0x01) == 0x01)
      {printf("Drive 0 motor on.\n");
       if (((*bytepntr) & 0x80) == 0x80) printf("Diskette write or format in progress.\n");
         else printf("Diskette read or seek in progress.\n");
      }
    break;
    default : printf("Error in readin Diskette Recalibration Byte!!!\n");
   }

   /* Ignored due to irregular readings, I must investigate. */
   /* Diskette Motor Time Out Byte */
/*   bytepntr = MK_FP(BiosDataSeg, DsktMotorOffTime);
   printf("Diskette Motor Time Out  %x \n",*bytepntr);
*/
   /* Diskette Last Operation Byte */
   bytepntr = MK_FP(BiosDataSeg, DsktLastOpStatus);
   printf("\nDiskette Last Operation Status Byte : %x \n",*bytepntr);
   printf("============================================\n");
   if (((*bytepntr) & 0x00) == 0x00) printf("NO ERRORS on Last Operation.\n");
   else
    {if (((*bytepntr) & 0x80) == 0x80) printf("Drive Not Ready!\n");
     if (((*bytepntr) & 0x40) == 0x40) printf("Drive Seek Error.\n");
     if (((*bytepntr) & 0x20) == 0x20) printf("General Drive Controller Error.\n");
     error_status = (*bytepntr) & 0x1f;
     switch (error_status)
     {default : printf("Undocumented Error.\n");
        break;
      case 0x10 : printf("CRC error on Read.\n");
        break;
      case 0x0c : printf("Media type unknown.**\n");
        break;
      case 0x09 : printf("DMA Request across 64k Boundary.\n");
        break;
      case 0x08 : printf("DMA Over run.\n");
        break;
      case 0x06 : printf("Diskete Line Change.**\n");
        break;
      case 0x04 : printf("Sector not found.\n");
        break;
      case 0x03 : printf("Write Protected Diskette.\n");
        break;
      case 0x02 : printf("Address mark not found on Diskette.\n");
        break;
      case 0x01 : printf("Invalid command to Controller.\n");
        break;
     } /* End Switch */
    }

   /* NEC 765A Diskette Controler Status from Last Operation */
   printf("\nNEC 765A Controller Status Bytes (7 bytes) --\n");
   printf("=============================================\n");
   for (i = 0; i < 7 ; i+=4)
     {bytepntr = MK_FP(BiosDataSeg, DsktStatusCmd + i);
      printf("Byte%d %2x \t",i + 1,*bytepntr);
      printf("Byte%d %2x \t",i + 2,*(bytepntr + 1));
      printf("Byte%d %2x \t",i + 3,*(bytepntr + 2));
      if (i < 4) printf("Byte%d %2x ",i + 4,*(bytepntr + 3));
      printf("\n");
     }

   /*  Main Status Register from the FDC */
   /*  This works, but i removed it from display to save room on the screen  */
   /*
   porta = Main_Status_R;
   bytea = inp(porta);
   printf("\nThe Main Status Register, port #%x, is %x hex\n",porta,bytea);
   printf("============================================\n");
   if ((bytea & 0x80) == 0x80) printf("Controller Ready,");
     else printf("Controller NOT Ready,");
   if ((bytea & 0x40) == 0x40) printf(" waiting to be read,");
     else printf(" waiting to be written to,");
   if ((bytea & 0x20) == 0x20) printf(" Access is in NON-DMA mode.\n");
     else printf(" Access is in DMA mode.\n");
   if ((bytea & 0x10) == 0x10) printf("Controller Busy.\n");
   switch (num_of_diskettes)
   {case 4 :
     if (((*bytepntr) & 0x08) == 0x08) printf("Drive 3 busy seeking.\n");
    case 3 :
     if (((*bytepntr) & 0x04) == 0x04) printf("Drive 2 busy seeking.\n");
    case 2 :
     if (((*bytepntr) & 0x02) == 0x02) printf("Drive 1 busy seeking.\n");
    case 1 :
     if (((*bytepntr) & 0x01) == 0x01) printf("Drive 0 busy seeking.\n");
    break;
    default : printf("Error in readin Diskette Recalibration Byte!!!\n");
   }
*/

    exit (0);
  }


